% * Copyright (c) 2014, Andrew Kae, UMass Amherst
% * All rights reserved.
% *
% * Redistribution and use in source and binary forms, with or without
% * modification, are permitted provided that the following conditions are met:
% *     * Redistributions of source code must retain the above copyright
% *       notice, this list of conditions and the following disclaimer.
% *     * Redistributions in binary form must reproduce the above copyright
% *       notice, this list of conditions and the following disclaimer in the
% *       documentation and/or other materials provided with the distribution.
% *     * Neither the name of the author nor the organization may be used to 
% *       endorse or promote products derived from this software without specific 
% *       prior written permission.
% *
% * THIS SOFTWARE IS PROVIDED BY Andrew Kae ``AS IS'' AND ANY
% * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% * DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
% * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
% * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
% * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
% * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

% Code used in the following papers : 
% 
% * Gary B. Huang, Andrew Kae, Carl Doersch, and Erik Learned-Miller
%   Bounding the Probability of Error for High Precision Optical Character Recognition.
%   Journal of Machine Learning Research (JMLR), 2012. 
%
% * Andrew Kae, Gary Huang, Carl Doersch, and Erik Learned-Miller
%   Improving State-of-the-Art OCR through High-Precision Document-Specific Modeling
%   Proceedings of the IEEE Conference on Computer Vision and Pattern Recognition (CVPR), 2010.

% Load local directories/paths
startup_directory;

addpath(sift_dir);

[docs ids] = textread('doc_list.txt', '%s %d');

num_docs = numel(ids);

for d=1:num_docs

    % Extract features from the clean set, and generate files used in SVM classification.
    multi_class_sift_align(root_dir, svm_dir, model_dir, docs{d}, ids(d));
    
end