%find the best alignment within the cetner of a patch to a given mean sift descriptor 
function [min_dist, min_dp, best_offset] = sift_search(patch, mean_dp, metric, magnif, sigma, num_spatial_bins, num_orient_bins) 

    %examine the points near the center of the small patch
    [height, width] = size(patch);

    mid_x = round(width / 2);
    mid_y = round(height / 2);

    window = 5;
        
	xmin = max(1, mid_x - window);
    xmax = min(width, mid_x + window);
    
	ymin = max(1, mid_y - window);
    ymax = min(height, mid_y + window);

	min_dist = inf;    
    
    best_offset = [];
    
    for x=xmin:xmax
        for y=ymin:ymax
            %note that we have to do x-1, y-1 because C starts its indexing at 0 while matlab is 1
            dp = siftdescriptor(patch, [x - 1; y - 1; 0], sigma, 'NumSpatialBins', num_spatial_bins, ...
                'Magnif', magnif, 'NumOrientBins', num_orient_bins) ;                        
            
            dist = [];

            %calculate the distance using the metric given
            if (strcmp(metric, 'L1'))
                %manhattan distance
                dist = sum(abs(mean_dp - dp));
            else
                %euclidean distance
                dist = sqrt(sum((mean_dp - dp).^2));
            end

            if (dist < min_dist)
                min_dist = dist;
                min_dp = dp;

                best_offset = [y x];
            end            
        end
    end       
end